(function ($, Drupal) {
  Drupal.behaviors.csvDatatables = {
    attach: function attach(context, settings) {
      $('table.dataTable').DataTable();

      $(context).find('pre.csv-table').each(function() {
        var parsed = Papa.parse(this.innerHTML);

        if (!parsed) {
          $(this).remove();
        }

        var table = document.createElement("table");
        this.classList.remove("csv-table");
        table.classList = this.classList;
        this.parentNode.replaceChild(table, this);

        if (table.classList.contains("dataTable")) {
          var i;
          var columns = [];
          var headerData = parsed.data.shift();
          for (i = 0; i < headerData.length; i++) {
            columns.push({ title: headerData[i] });
          }

          $(table).DataTable( {
            paging: true,
            searching: true,
            data: parsed.data,
            columns: columns,
          } );
        }
        else {
          var lines = parsed.data,
            output = [],
            i;
          // Add header.
          output.push("<thead><tr><th>" + lines[0].join("</th><th>") + "</th></tr></thead><tbody>");

          // Add other rows.
          for (i = 1; i < lines.length; i++)
            output.push("<tr><td>" + lines[i].join("</td><td>") + "</td></tr>");

          output = output.join("") + "</tbody>";

          this.classList.remove("csv-table");
          table.classList = this.classList;
          table.innerHTML = output;
        }
      });

    }
  };
})(jQuery, Drupal);
